<?php

class fieldListurl extends cmsFormField {

    public $title = 'Список со ссылкой';
    public $sql   = 'int NULL DEFAULT NULL';
    public $filter_type = 'int';
    public $filter_hint = LANG_PARSER_LIST_FILTER_HINT;
    
    public function getOptions(){
        return array(
	    new fieldCheckbox('redirect', array(
                'title' => 'использовать встроенный редирект',
                'default' => false
            )),
	    new fieldCheckbox('blank', array(
                'title' => 'открывать ссылку в новом окне?',
                'default' => false
            ))
        );
    }

    public function getFilterInput($value) {

        $items = $this->getListItems();
	
	$i = 1;
	foreach($items as $item){
	    list($title[$i], $link) = explode('*', $item);
	    $i++;
	}


            $title = array(''=>'') + $title;// array_pad($items, (sizeof($items)+1)*-1, '');
            return html_select($this->name, $title, $value);


    }

    public function getRules() {

        if($this->item){
            $this->rules[] = array('array_key', array('0' => "") + $this->getListItems());
        }

        return $this->rules;

    }

    public function parse($value){

        $items = $this->getListItems();
        $item  = '';

        if (isset($items[$value])) { $item = $items[$value]; }
	
	list($title, $link) = explode('*', $item);
	
    if ($this->getOption('redirect')){
            $config = cmsConfig::getInstance();
            $link = $config->root . 'redirect?url=' . $link;
        }
	
	if ($this->getOption('blank')){
            $target = 'target="_blank" ';
        }else{
	    $target = '';
	}

        return "<a ".$target."href='".$link."'>".$title."</a>";;

    }

    public function getListItems(){

        $items = array();

        if (isset($this->items)){

            $items = $this->items;

        } else if (isset($this->generator)) {

            $generator = $this->generator;
            $items = $generator($this->item);

        } else if ($this->hasDefaultValue()) {

            $items = $this->parseListItems($this->getDefaultValue());

        }

        return $items;

    }

    public function parseListItems($string){
        return string_explode_list($string);
    }

    public function applyFilter($model, $value) {


            $model->filterEqual($this->name, $value);

        return $model;

    }

    public function getInput($value){

        $this->data['items']        = $this->getListItems();
	$this->data['dom_attr']     = array('id'=>$this->id);

        return parent::getInput($value);

    }

}
